; Assembly Source File
; Created 26/06/03, 18:40:43
; getkey from Seawar 2.0, with (lots of) modifications

;_fargo equ 1

 	include "sprites.h"

	xdef getkey
	xdef wait_a_key
	xdef wait_no_key
	xdef CustomSprite16x15_or
	xdef SaveAndReplaceInts
	xdef RestoreInts

SIZEOF_RTE equ 2

key_test MACRO
	btst.b	#\2,-2-2*\1(a7)
	bne.s	\@0
	bset.b	#\3,d0
\@0
	ENDM

 void_int:	dc.w	$4E73
 save_int_1:	dc.l	0
 save_int_2:	dc.l	0
 save_int_5:	dc.l	0

SaveAndReplaceInts:

	lea	void_int(pc),a0
	movea.l	#$600001,a1
	bclr.b #2,(a1)				; unprotects low memory

	move.l	($60+4*1).w,SIZEOF_RTE+0(a0)	; rte is 2 bytes
	move.l	($60+4*2).w,SIZEOF_RTE+4(a0)
	move.l	($60+4*5).w,SIZEOF_RTE+8(a0)

	move.l	a0,($60+4*1).w
	move.l	a0,($60+4*2).w
	move.l	a0,($60+4*5).w

	bset.b	#2,(a1)				; re-protects low memory
	rts

RestoreInts:

	lea	void_int(pc),a0
	movea.l	#$600001,a1
	bclr.b #2,(a1)				; unprotects low memory

	move.l	SIZEOF_RTE+0(a0),($60+4*1).w	; rte is 2 bytes
	move.l	SIZEOF_RTE+4(a0),($60+4*2).w
	move.l	SIZEOF_RTE+8(a0),($60+4*5).w

	bset.b	#2,(a1)				; re-protects low memory
	rts

;getkey
;	input: nothing (but buffers in datas)
;	output: d0.w
;	destroy: d0-d2/a0
;	gets keys... returns d0
;
;	|	key (92/89)	|	d0.w	|
;	+-----------------------+---------------+
;	|	none		|	0	|
;	|	up		|	+1	|
;	|	down		|	+2	|
;	|	right		|	+4	|
;	|	left		|	+8	|
;	|	esc		|	+16	|
;	|	enter/2nd	|	+32	|
;	|	hand		|	+32	|
;

wait_no_key:
	bsr.s	getkey
	dbra.s	d0,wait_no_key
	rts

wait_a_key:
	bsr.s	getkey
	tst.w	d0
	beq.s	wait_a_key
	rts

getkey:

 ScanKbd:				; keyScan par ExtendeD (modified... a lot)

	moveq.l	#9,d0
	moveq.l	#-2,d2
	movea.l	#$600018,a0

 SaveRow:

	move.w	d2,(a0)
	moveq.l	#11,d1			; d1=0

 WaitKeys:

	dbra.s	d1,WaitKeys		; copy the ports to a virtual keybord table

	move.b	3(a0),-(a7)		; a7 will we incremented of 2 !!
	rol.w	#1,d2
	dbra.s	d0,SaveRow

	lea.l	20(a7),a7		; restore the stack

	moveq.l	#0,d0

	ifeq _fargo
	tst.w	__calculator - __relation (a4)
	beq.s	enter_test_89
	endif

 enter_test_92:
	key_test 0,3,5			; affect to each key its number
	key_test 6,6,5
	key_test 9,1,5

 up_test_92:
 	key_test 0,5,0

 down_test_92:
 	key_test 0,7,1

 right_test_92:
	key_test 0,6,2

 left_test_92:
	key_test 0,4,3

 esc_test_92:
	key_test 8,6,4

	rts
 ifeq _fargo
 enter_test_89:
	key_test 1,0,5
	key_test 0,4,5

 up_test_89:
 	key_test 0,0,0

 down_test_89:
 	key_test 0,2,1

 right_test_89:
	key_test 0,3,2

 left_test_89:
	key_test 0,1,3

 esc_test_89:
	key_test 6,0,4

 getkey_end:

 	rts
 endif

CustomSprite16x15_or:
; void Sprite16x15x4_or(register short x asm("%d0"),register short y asm("%d1"),register short nbr asm("%d2"),register void *dest0 asm("%a0"),register void *dest1 asm("%a1"));

	move.l	a2,-(a7)
	move.l	d3,-(a7)

	cmp.w	#6,d2
	bgt.s	monochrome

	moveq.l	#28,d3
	add.w	d2,d2
	bra.s	spr_common

 monochrome:

	moveq.l	#-2,d3
	addq.w	#7,d2

 spr_common:

 	mulu.w	#30,d2
	lea	spr_list(pc),a2
	adda.w	d2,a2

	move.w	d1,d2
	lsl.w	#4,d1
	sub.w	d2,d1

	move.w	d0,d2
	lsr.w	#4,d2

	add.w	d2,d1
	add.w	d1,d1
	adda.w	d1,a0
	adda.w	d1,a1

	moveq.l	#16-1,d2

	and.w	d2,d0
	moveq.l	#16,d1
	sub.w	d0,d1

	subq.w	#1,d2

 loop:

	moveq.l	#0,d0
	move.w	(a2)+,d0
	lsl.l	d1,d0
	or.l	d0,(a0)

	moveq.l	#0,d0
	move.w	0(a2,d3.w),d0
	lsl.l	d1,d0
	or.l	d0,(a1)

	lea.l	30(a0),a0
	lea.l	30(a1),a1

	dbra.s	d2,loop

	move.l	(a7)+,d3
	move.l	(a7)+,a2

	rts
